# Oracle

## Oracle

| Option           | Info                                                                                   |
| ---------------- | -------------------------------------------------------------------------------------- |
| Type             | Relational                                                                             |
| Driver           | [Driver Link](https://www.oracle.com/database/technologies/appdev/jdbc-downloads.html) |
| Version Included | None                                                                                   |
| Hop Dependencies | None                                                                                   |
| Documentation    | [Documentation Link](https://docs.oracle.com/cd/E11882_01/java.112/e16548/toc.htm)     |
| JDBC Url         | jdbc:oracle:thin:@hostname:port Number:databaseName                                    |
| Driver folder    | \<Hop Installation>/lib/jdbc                                                           |

{% hint style="info" %}
Starting with Oracle Database 11g Release 1 (11.1), data type `Date` will be mapped to `Timestamp` by default. Set JDBC property `oracle.jdbc.mapDateToTimestamp=false` to avoid data type `Date` being converted to data type `Timestamp`.\
Check [Options](/data-shaper-1.21/knowing-the-data-shaper-designer/relational-database-connections.md#options) in the Relational Database Connection docs for more information.
{% endhint %}

### Creating connections

There are 4 ways to create a connection to an Oracle database in Apache Hop:

* If you have a SID, use this (old) format: `jdbc:oracle:thin:@hostname:PORT:SID`.\
  Put the SID with `:` prefix in the database name
* If you have a service name, use this (newer) format: `jdbc:oracle:thin:@//HOSTNAME:PORT/SERVICENAME`.\
  Put the service name with `/` prefix in the database name
* If you want to use TNS format: `jdbc:oracle:thin:@(DESCRIPTION=(ADDRESS=(PROTOCOL=TCP)(HOST=host) (PORT=port)) (CONNECT_DATA=(SERVICE_NAME=service_name))`.\
  Put the TNS description in the database name and leave the hostname and port empty.
* If you want to use a specific TNS\_ADMIN, you providing the path for tnsnames.ora through TNS\_ADMIN property: `jdbc:oracle:thin:@mydb.mydomain?TNS_ADMIN=C:\\Temp\\tns`\
  Use manual connection url (not the options tab because Apache Hop does not pass options in the url for Oracle).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.primeur.com/data-shaper-1.21/knowing-the-data-shaper-designer/relational-database-connections/oracle.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
